ghc-9.6.3: The GHC API

Safe Haskell | Safe-Inferred
Language | Haskell2010

GHC.Core.Coercion.Axiom

Contents

- Orphan instances

Description

Module for coercion axioms, used to represent type family instances and newtypes

Synopsis

- data BranchFlag
- type Branched = 'Branched
- type Unbranched = 'Unbranched
- type BranchIndex = Int
- newtype Branches (br :: BranchFlag) = MkBranches {
  - unMkBranches :: Array BranchIndex CoAxBranch
  }
- manyBranches :: [CoAxBranch] -> Branches Branched
- unbranched :: CoAxBranch -> Branches Unbranched
- fromBranches :: Branches br -> [CoAxBranch]
- numBranches :: Branches br -> Int
- mapAccumBranches :: ([CoAxBranch] -> CoAxBranch -> CoAxBranch) -> Branches br -> Branches br
- data CoAxiom br = CoAxiom {
  - co_ax_unique :: Unique
  - co_ax_name :: Name
  - co_ax_role :: Role
  - co_ax_tc :: TyCon
  - co_ax_branches :: Branches br
  - co_ax_implicit :: Bool
  }
- data CoAxBranch = CoAxBranch {
  - cab_loc :: SrcSpan
  - cab_tvs :: [TyVar]
  - cab_eta_tvs :: [TyVar]
  - cab_cvs :: [CoVar]
  - cab_roles :: [Role]
  - cab_lhs :: [Type]
  - cab_rhs :: Type
  - cab_incomps :: [CoAxBranch]
  }
- toBranchedAxiom :: CoAxiom br -> CoAxiom Branched
- toUnbranchedAxiom :: CoAxiom br -> CoAxiom Unbranched
- coAxiomName :: CoAxiom br -> Name
- coAxiomArity :: CoAxiom br -> BranchIndex -> Arity
- coAxiomBranches :: CoAxiom br -> Branches br
- coAxiomTyCon :: CoAxiom br -> TyCon
- isImplicitCoAxiom :: CoAxiom br -> Bool
- coAxiomNumPats :: CoAxiom br -> Int
- coAxiomNthBranch :: CoAxiom br -> BranchIndex -> CoAxBranch
- coAxiomSingleBranch_maybe :: CoAxiom br -> Maybe CoAxBranch
- coAxiomRole :: CoAxiom br -> Role
- coAxiomSingleBranch :: CoAxiom Unbranched -> CoAxBranch
- coAxBranchTyVars :: CoAxBranch -> [TyVar]
- coAxBranchCoVars :: CoAxBranch -> [CoVar]
- coAxBranchRoles :: CoAxBranch -> [Role]
- coAxBranchLHS :: CoAxBranch -> [Type]
- coAxBranchRHS :: CoAxBranch -> Type
- coAxBranchSpan :: CoAxBranch -> SrcSpan
- coAxBranchIncomps :: CoAxBranch -> [CoAxBranch]
- placeHolderIncomps :: [CoAxBranch]
- data Role
  - = Nominal
  - | Representational
  - | Phantom
- fsFromRole :: Role -> FastString
- data CoAxiomRule = CoAxiomRule {
  - coaxrName :: FastString
  - coaxrAsmpRoles :: [Role]
  - coaxrRole :: Role
  - coaxrProves :: [TypeEqn] -> Maybe TypeEqn
  }
- type TypeEqn = Pair Type
- data BuiltInSynFamily = BuiltInSynFamily {
  - sfMatchFam :: [Type] -> Maybe (CoAxiomRule, [Type], Type)
  - sfInteractTop :: [Type] -> Type -> [TypeEqn]
  - sfInteractInert :: [Type] -> Type -> [Type] -> Type -> [TypeEqn]
  }
- trivialBuiltInFamily :: BuiltInSynFamily

# Documentation

data BranchFlag Source #

type Branched = 'Branched Source #

type Unbranched = 'Unbranched Source #

type BranchIndex = Int Source #

newtype Branches (br :: BranchFlag) Source #

Constructors

MkBranches |

Fields

- unMkBranches :: Array BranchIndex CoAxBranch

manyBranches :: [CoAxBranch] -> Branches Branched Source #

unbranched :: CoAxBranch -> Branches Unbranched Source #

fromBranches :: Branches br -> [CoAxBranch] Source #

numBranches :: Branches br -> Int Source #

mapAccumBranches :: ([CoAxBranch] -> CoAxBranch -> CoAxBranch) -> Branches br -> Branches br Source #

The `[CoAxBranch]` passed into the mapping function is a list of all previous branches, reversed

data CoAxiom br Source #

A `CoAxiom` is a "coercion constructor", i.e. a named equality axiom.

Constructors

CoAxiom |

Fields

- co_ax_unique :: Unique
- co_ax_name :: Name
- co_ax_role :: Role
- co_ax_tc :: TyCon
- co_ax_branches :: Branches br
- co_ax_implicit :: Bool

#### Instances

Instances details

Typeable br => Data (CoAxiom br) Source # |

Instance details

Defined in GHC.Core.Coercion.Axiom

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> CoAxiom br -> c (CoAxiom br) Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c (CoAxiom br) Source #

toConstr :: CoAxiom br -> Constr Source #

dataTypeOf :: CoAxiom br -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c (CoAxiom br)) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c (CoAxiom br)) Source #

gmapT :: (forall b. Data b => b -> b) -> CoAxiom br -> CoAxiom br Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> CoAxiom br -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> CoAxiom br -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> CoAxiom br -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> CoAxiom br -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> CoAxiom br -> m (CoAxiom br) Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> CoAxiom br -> m (CoAxiom br) Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> CoAxiom br -> m (CoAxiom br) Source #

NamedThing (CoAxiom br) Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods getOccName :: CoAxiom br -> OccName Source # getName :: CoAxiom br -> Name Source #
Uniquable (CoAxiom br) Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods getUnique :: CoAxiom br -> Unique Source #
Outputable (CoAxiom br) Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods ppr :: CoAxiom br -> SDoc Source #
Eq (CoAxiom br) Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods (==) :: CoAxiom br -> CoAxiom br -> Bool # (/=) :: CoAxiom br -> CoAxiom br -> Bool #

data CoAxBranch Source #

Constructors

CoAxBranch |

Fields

- cab_loc :: SrcSpan
- cab_tvs :: [TyVar]
- cab_eta_tvs :: [TyVar]
- cab_cvs :: [CoVar]
- cab_roles :: [Role]
- cab_lhs :: [Type]
- cab_rhs :: Type
- cab_incomps :: [CoAxBranch]

#### Instances

Instances details

Data CoAxBranch Source # |

Instance details

Defined in GHC.Core.Coercion.Axiom

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> CoAxBranch -> c CoAxBranch Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c CoAxBranch Source #

toConstr :: CoAxBranch -> Constr Source #

dataTypeOf :: CoAxBranch -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c CoAxBranch) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c CoAxBranch) Source #

gmapT :: (forall b. Data b => b -> b) -> CoAxBranch -> CoAxBranch Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> CoAxBranch -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> CoAxBranch -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> CoAxBranch -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> CoAxBranch -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> CoAxBranch -> m CoAxBranch Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> CoAxBranch -> m CoAxBranch Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> CoAxBranch -> m CoAxBranch Source #

Outputable CoAxBranch Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods ppr :: CoAxBranch -> SDoc Source #

toBranchedAxiom :: CoAxiom br -> CoAxiom Branched Source #

toUnbranchedAxiom :: CoAxiom br -> CoAxiom Unbranched Source #

coAxiomName :: CoAxiom br -> Name Source #

coAxiomArity :: CoAxiom br -> BranchIndex -> Arity Source #

coAxiomBranches :: CoAxiom br -> Branches br Source #

coAxiomTyCon :: CoAxiom br -> TyCon Source #

isImplicitCoAxiom :: CoAxiom br -> Bool Source #

coAxiomNumPats :: CoAxiom br -> Int Source #

coAxiomNthBranch :: CoAxiom br -> BranchIndex -> CoAxBranch Source #

coAxiomSingleBranch_maybe :: CoAxiom br -> Maybe CoAxBranch Source #

coAxiomRole :: CoAxiom br -> Role Source #

coAxiomSingleBranch :: CoAxiom Unbranched -> CoAxBranch Source #

coAxBranchTyVars :: CoAxBranch -> [TyVar] Source #

coAxBranchCoVars :: CoAxBranch -> [CoVar] Source #

coAxBranchRoles :: CoAxBranch -> [Role] Source #

coAxBranchLHS :: CoAxBranch -> [Type] Source #

coAxBranchRHS :: CoAxBranch -> Type Source #

coAxBranchSpan :: CoAxBranch -> SrcSpan Source #

coAxBranchIncomps :: CoAxBranch -> [CoAxBranch] Source #

placeHolderIncomps :: [CoAxBranch] Source #

data Role Source #

See Note [Roles] in GHC.Core.Coercion

Order of constructors matters: the Ord instance coincides with the *super*typing relation on roles.

Constructors

Nominal |
Representational |
Phantom |

#### Instances

Instances details

Data Role Source # |

Instance details

Defined in Language.Haskell.Syntax.Basic

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Role -> c Role Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Role Source #

toConstr :: Role -> Constr Source #

dataTypeOf :: Role -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Role) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Role) Source #

gmapT :: (forall b. Data b => b -> b) -> Role -> Role Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Role -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Role -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Role -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Role -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Role -> m Role Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Role -> m Role Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Role -> m Role Source #

Binary Role Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods put_ :: BinHandle -> Role -> IO () Source # put :: BinHandle -> Role -> IO (Bin Role) Source # get :: BinHandle -> IO Role Source #
Outputable Role Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods ppr :: Role -> SDoc Source #
Eq Role Source # |
Instance details Defined in Language.Haskell.Syntax.Basic Methods (==) :: Role -> Role -> Bool # (/=) :: Role -> Role -> Bool #
Ord Role Source # |
Instance details Defined in Language.Haskell.Syntax.Basic Methods compare :: Role -> Role -> Ordering # (<) :: Role -> Role -> Bool # (<=) :: Role -> Role -> Bool # (>) :: Role -> Role -> Bool # (>=) :: Role -> Role -> Bool # max :: Role -> Role -> Role # min :: Role -> Role -> Role #
type Anno (Maybe Role) Source # |
Instance details Defined in GHC.Hs.Decls type Anno (Maybe Role) = SrcAnn NoEpAnns
type Anno (Maybe Role) Source # |
Instance details Defined in GHC.Hs.Decls type Anno (Maybe Role) = SrcAnn NoEpAnns

fsFromRole :: Role -> FastString Source #

data CoAxiomRule Source #

For now, we work only with nominal equality.

Constructors

CoAxiomRule |

Fields

- coaxrName :: FastString
- coaxrAsmpRoles :: [Role]
- coaxrRole :: Role
- coaxrProves :: [TypeEqn] -> Maybe TypeEqn

  coaxrProves returns `Nothing` when it doesn't like the supplied arguments. When this happens in a coercion that means that the coercion is ill-formed, and Core Lint checks for that.

#### Instances

Instances details

Data CoAxiomRule Source # |

Instance details

Defined in GHC.Core.Coercion.Axiom

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> CoAxiomRule -> c CoAxiomRule Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c CoAxiomRule Source #

toConstr :: CoAxiomRule -> Constr Source #

dataTypeOf :: CoAxiomRule -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c CoAxiomRule) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c CoAxiomRule) Source #

gmapT :: (forall b. Data b => b -> b) -> CoAxiomRule -> CoAxiomRule Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> CoAxiomRule -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> CoAxiomRule -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> CoAxiomRule -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> CoAxiomRule -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> CoAxiomRule -> m CoAxiomRule Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> CoAxiomRule -> m CoAxiomRule Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> CoAxiomRule -> m CoAxiomRule Source #

Uniquable CoAxiomRule Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods getUnique :: CoAxiomRule -> Unique Source #
Outputable CoAxiomRule Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods ppr :: CoAxiomRule -> SDoc Source #
Eq CoAxiomRule Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods (==) :: CoAxiomRule -> CoAxiomRule -> Bool # (/=) :: CoAxiomRule -> CoAxiomRule -> Bool #
Ord CoAxiomRule Source # |
Instance details Defined in GHC.Core.Coercion.Axiom Methods compare :: CoAxiomRule -> CoAxiomRule -> Ordering # (<) :: CoAxiomRule -> CoAxiomRule -> Bool # (<=) :: CoAxiomRule -> CoAxiomRule -> Bool # (>) :: CoAxiomRule -> CoAxiomRule -> Bool # (>=) :: CoAxiomRule -> CoAxiomRule -> Bool # max :: CoAxiomRule -> CoAxiomRule -> CoAxiomRule # min :: CoAxiomRule -> CoAxiomRule -> CoAxiomRule #

type TypeEqn = Pair Type Source #

A more explicit representation for `t1 ~ t2`.

data BuiltInSynFamily Source #

Constructors

BuiltInSynFamily |

Fields

- sfMatchFam :: [Type] -> Maybe (CoAxiomRule, [Type], Type)
- sfInteractTop :: [Type] -> Type -> [TypeEqn]
- sfInteractInert :: [Type] -> Type -> [Type] -> Type -> [TypeEqn]

trivialBuiltInFamily :: BuiltInSynFamily Source #

# Orphan instances

Binary Role Source # |
Instance details Methods put_ :: BinHandle -> Role -> IO () Source # put :: BinHandle -> Role -> IO (Bin Role) Source # get :: BinHandle -> IO Role Source #
Outputable Role Source # |
Instance details Methods ppr :: Role -> SDoc Source #